/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.ObjekModulAplikasi;

@Lazy
@Repository
public interface ObjekModulAplikasiDao extends CrudRepository<ObjekModulAplikasi, String> {

	Long countByAlamatURLFormObjek(String alamatURLFormObjek);
	

	@Query("select model from ObjekModulAplikasi model")
	List<ObjekModulAplikasi> findAllList(Pageable page);

	@Query("select model from ObjekModulAplikasi model where model.namaObjekModulAplikasi like %:namaObjekModulAplikasi% or (model.kdObjekModulAplikasi in (select model2.kdObjekModulAplikasiHead from ObjekModulAplikasi model2 where model2.namaObjekModulAplikasi like %:namaObjekModulAplikasi%  and model2.statusEnabled=true ))")
	List<ObjekModulAplikasi> findAllList(@Param("namaObjekModulAplikasi")String namaObjekModulAplikasi, Pageable page);

	@Query("select model from ObjekModulAplikasi model where model.statusEnabled=true")
	List<ObjekModulAplikasi> findAllListCombo(Pageable page);

	@Query("select model from ObjekModulAplikasi model where model.statusEnabled=true and model.namaObjekModulAplikasi like %:namaObjekModulAplikasi% or (model.kdObjekModulAplikasi in (select model2.kdObjekModulAplikasiHead from ObjekModulAplikasi model2 where model2.namaObjekModulAplikasi like %:namaObjekModulAplikasi%  and model2.statusEnabled=true ))")
	List<ObjekModulAplikasi> findAllListCombo(@Param("namaObjekModulAplikasi")String namaObjekModulAplikasi, Pageable page);
	
	@Query("select  model from ObjekModulAplikasi model where model.kdObjekModulAplikasi=:kdObjekModulAplikasi "
			+ "or (model.kdObjekModulAplikasi in (select model2.kdObjekModulAplikasiHead from ObjekModulAplikasi model2 where model2.kdObjekModulAplikasi=:kdObjekModulAplikasi ))"
			+ "or (model.kdObjekModulAplikasiHead in (select model2.kdObjekModulAplikasi from ObjekModulAplikasi model2 where model2.kdObjekModulAplikasi=:kdObjekModulAplikasi )) ")
	List<ObjekModulAplikasi> findByKdObjekModulAplikasiWithIsHierarkiTrue(@Param("kdObjekModulAplikasi") String kdObjekModulAplikasi);
	
	@Query("select model from ObjekModulAplikasi model where model.kdObjekModulAplikasi=:kdObjekModulAplikasi ")
	List<ObjekModulAplikasi> findByKdObjekModulAplikasiWithIsHierarkiFalse(@Param("kdObjekModulAplikasi") String kdObjekModulAplikasi);

	@Query("select new map(model.kdObjekModulAplikasi as kdObjekModulAplikasi "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi,model.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead) from ObjekModulAplikasi model where model.kdObjekModulAplikasiHead=:kdObjekModulAplikasi and  model.statusEnabled = true  ")
	List<Map<String, Object>> findObjekModulAplikasiByHead(@Param("kdObjekModulAplikasi") String kdObjekModulAplikasi);


	@Query("select new map(model.kdObjekModulAplikasi as kode "
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", modApp.kdModulAplikasiHead as kdModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "
			+ ", modApp.namaModulAplikasi as nama "
			+ ", 0 as tampil "
			+ ", 0 as simpan "
			+ ", 0 as ubah "
			+ ", 0 as hapus "
			+ ", 0 as cetak "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " left join mmApp.modulAplikasi modApp "
			+ " where  model.statusEnabled = true ")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuMapObjek();


	@Query("select new map(model.kdObjekModulAplikasi as kode "  
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "  
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", modApp.kdModulAplikasiHead as kdModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "  
			+ ", modApp.namaModulAplikasi as nama " 
			+ ", mkUser.id.kdKelompokUser as kdKelompokUser "
			+ ", mkUser.tampil as tampil "
			+ ", mkUser.simpan as simpan "
			+ ", mkUser.ubah as ubah "
			+ ", mkUser.hapus as hapus "
			+ ", mkUser.cetak as cetak"
			+ ", mkUser.statusEnabled as statusEnabled "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapObjekModulToKelompokUser mkUser "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " left join mmApp.modulAplikasi modApp "
			+ " where mkUser.id.kdProfile = :kdProfile "
			+ " and mkUser.id.kdKelompokUser = :kdKelompokUser  "
			+ " and model.statusEnabled = true ")
	//@Cacheable("ObjekModulAplikasiDaofindMenu1")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuKelompoUser(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdKelompokUser") Integer kdKelompokUser);


	@Query("select new map(model.kdObjekModulAplikasi as kode "
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", model.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "
			+ ", modApp.namaModulAplikasi as nama "
			+ ", 0 as tampil "
			+ ", 0 as simpan "
			+ ", 0 as ubah "
			+ ", 0 as hapus "
			+ ", 0 as cetak "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " left join mmApp.modulAplikasi modApp "
			+ " where model.statusEnabled = true "
			+ " and model.kdObjekModulAplikasiHead is null and mmApp.id.kdVersion=:kdVersion and mmApp.statusEnabled=true and mmApp.id.kdModulAplikasi=:kdModulAplikasi ")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuMapObjekHead(@Param("kdVersion") Integer kdVersion, @Param("kdModulAplikasi")String kdModulAplikasi);


	@Query("select new map(model.kdObjekModulAplikasi as kode "  
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "  
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", model.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "  
			+ ", modApp.namaModulAplikasi as nama " 
			+ ", mkUser.id.kdKelompokUser as kdKelompokUser "
			+ ", mkUser.tampil as tampil "
			+ ", mkUser.simpan as simpan "
			+ ", mkUser.ubah as ubah "
			+ ", mkUser.hapus as hapus "
			+ ", mkUser.cetak as cetak"
			+ ", mkUser.statusEnabled as statusEnabled"
			+ ", mkUser.id.kdVersion as kdVersion "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join MapObjekModulToKelompokUser mkUser on model.kdObjekModulAplikasi=mkUser.id.kdObjekModulAplikasi"
			+ " left join MapModulAplikasiToObjekModul mmApp on model.kdObjekModulAplikasi=mmApp.id.kdObjekModulAplikasi"
			+ " left join mmApp.modulAplikasi modApp "
			+ " where mkUser.id.kdProfile = :kdProfile "
			+ " and mkUser.id.kdKelompokUser = :kdKelompokUser  "
			+ " and model.statusEnabled = true "
			+ " and model.kdObjekModulAplikasiHead is null  and  modApp.kdModulAplikasi=mmApp.id.kdModulAplikasi and mkUser.id.kdModulAplikasi=:kdModulAplikasi and mkUser.id.kdVersion=:kdVersion")
	//@Cacheable("ObjekModulAplikasiDaofindMenu1")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuKelompoUserHead(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdKelompokUser") Integer kdKelompokUser,
			@Param("kdModulAplikasi") String kdModulAplikasi, Integer kdVersion
			);


	@Query("select new map(model.kdObjekModulAplikasi as kode "
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", model.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "
			+ ", modApp.namaModulAplikasi as nama "
			+ ", 0 as tampil "
			+ ", 0 as simpan "
			+ ", 0 as ubah "
			+ ", 0 as hapus "
			+ ", 0 as cetak "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join MapModulAplikasiToObjekModul mmApp on model.kdObjekModulAplikasi=mmApp.id.kdObjekModulAplikasi "
			+ " left join mmApp.modulAplikasi modApp "
			+ " where mmApp.statusEnabled = true "
			+ " and model.kdObjekModulAplikasiHead=:kdHead and mmApp.id.kdVersion=:kdVersion and modApp.kdModulAplikasi=mmApp.id.kdModulAplikasi and mmApp.id.kdModulAplikasi=:kdModulAplikasi ")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuMapObjekByHead(
			@Param("kdHead") String kdHead,@Param("kdVersion") Integer kdVersion,@Param("kdModulAplikasi") String kdModulAplikasi);


	@Query("select new map(model.kdObjekModulAplikasi as kode "  
			+ ", model.kdObjekModulAplikasi as kdObjekModulAplikasi "  
			+ ", modApp.kdModulAplikasi as kdModulAplikasi"
			+ ", model.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi "  
			+ ", modApp.namaModulAplikasi as nama " 
			+ ", mkUser.id.kdKelompokUser as kdKelompokUser "
			+ ", mkUser.tampil as tampil "
			+ ", mkUser.simpan as simpan "
			+ ", mkUser.ubah as ubah "
			+ ", mkUser.hapus as hapus "
			+ ", mkUser.cetak as cetak"
			+ ", mkUser.statusEnabled as statusEnabled "
			+ ") "
			+ " from ObjekModulAplikasi model "
			+ " left join MapObjekModulToKelompokUser  mkUser on model.kdObjekModulAplikasi=mkUser.id.kdObjekModulAplikasi and mkUser.statusEnabled=true "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " left join mmApp.modulAplikasi modApp "
			+ " where mkUser.id.kdProfile = :kdProfile "
			+ " and mkUser.id.kdKelompokUser = :kdKelompokUser  "
			+ " and model.statusEnabled = true "
			+ " and model.kdObjekModulAplikasiHead=:kdHead and mmApp.id.kdVersion=:kdVersion and mkUser.id.kdModulAplikasi=:kdModulAplikasi ")
	//@Cacheable("ObjekModulAplikasiDaofindMenu1")
	List<Map<String,Object>> findAllObjekModulAplikasiDaofindMenuKelompoUserByHead(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdHead") String kdHead,
			@Param("kdKelompokUser") Integer kdKelompokUser,@Param("kdVersion") Integer kdVersion,@Param("kdModulAplikasi") String kdModulAplikasi);


	List<ObjekModulAplikasi> findBykdObjekModulAplikasiHeadAndStatusEnabled(String kdObjekModulAplikasiHead,
			Boolean statusEnabled);
	
	

}
